#include <stdio.h>
#include <conio.h>
#include "forms3.h"

FormElement *element;
char msg[12];

// Initializes the form elements. This procedure is called from initForm.
void initFormElements(uint8_t formIdx) {

    switch (formIdx) {
        case 0:
            addField(ftText, 20, "Name", 10, 6, 17, 6, false);
            
            newAndLinkWithPrevElement();
            addField(ftInteger, 5, "Int", 10, 8, 17, 8, true);
          
            newAndLinkWithPrevElement();
            sprintf(msg, "Gr%c%ce in cm", CH_LC_OUML, CH_SZ);
            addField(ftNumNatural, 3, msg, 10, 10, 24, 10, false);
          
            newAndLinkWithPrevElement();
            addField(ftReal, 10, "Real", 10, 12, 24, 12, false);
          
            newAndLinkWithPrevElement();
            addField(ftDate, 10, "Geburtsdatum", 10, 14, 24, 14, false);
          
            newAndLinkWithPrevElement();
            addField(ftFileName, 14, "Dateiname", 10, 16, 24, 16, false);
          
            newAndLinkWithPrevElement();
            addButton(ok, 1, 18, 15, "OK");
          
            newAndLinkWithPrevElement();
            addButton(cancel, 20, 18, 15, "Abbrechen");

            break;
        case 1:
            addField(ftDate, 10, "Datum", 15, 6, 25, 6, false);
          
            newAndLinkWithPrevElement();
            addButton(ok, 15, 9, 15, "OK");
          
            newAndLinkWithPrevElement();
            addButton(cancel, 33, 9, 15, "Abbrechen");

            break;
    }
}


// Writes the current field's text and moves to the next element.
void nextField() {
  printf("%s\n", element->field->txt);
  element = element->next;
}


// Writes the current button's activation status and moves to the next element.
void nextButton() {
  if (element->button->activated)
      puts("yes");
  else
      puts("no");
  element = element->next;
}


// Displays a headline.
void headline() {
  clearScreen();
  puts("FORM3-Test\n\n\n");
}


int main(void) {
  setDecimalChar(',');
  setMessageLine(31);

  headline();
  puts("*** Form 1 ***");
  
  initForms(2, false);
  initForm(0);
  initForm(1);
  
  selectForm(0);
  setFieldText(1, "Preset text");
  
//  printFormElements(); // DEBUG

  processForm();

  gotoXY(0, 22);
  element = getFormFirstElement();
  printf("Name        : "); nextField();
  printf("Int         : "); nextField();
  printf("Gr%c%ce       : ", CH_LC_OUML, CH_SZ); nextField();
  printf("Real        : "); nextField();
  printf("Geburtsdatum: "); nextField();
  printf("Dateiname   : "); nextField();
  printf("OK          : "); nextButton();
  printf("Abbrechen   : "); nextButton();

  if (formCancelled()) {
    printf("Cancelled\n");
  }
  else {
    printf("Confirmed\n");
  }

  waitForKey();

  selectForm(1);
  headline();
  printf("*** Form 2 ***");
  
  processForm();

  gotoXY(0, 22);
  element = getFormFirstElement();
  printf("Datum       : "); nextField();
  printf("OK          : "); nextButton();
  printf("Abbrechen   : "); nextButton();
  if (formCancelled) {
    printf("Cancelled\n");
  }
  else {
    printf("Confirmed");
  }

  destroyForm(0);
  destroyForm(1);
  closeForms();

  waitForKey();
  
  return 0;
}
